.386
.model flat, stdcall
option casemap:none

; #####################################################################
;
;  Konvert: conversion de fichiers macs ou unix au format windows
;
;  Copyright 2000, 2001,2002 Bruno Berteau
;  Site web: http://bberteau.free.fr
;  Mail: bberteau@free.fr
;
;  This  program is  free software;  you can  redistribute  it and/or
;  modify it  under the  terms of the  GNU General Public  License as
;  published by the Free Software Foundation; either version 2 of the
;  License, or any later version.
;
;  This program  is distributed in the  hope that it  will be useful,
;  but  WITHOUT ANY WARRANTY;  without even  the implied  warranty of
;  MERCHANTABILITY or FITNESS FOR  A PARTICULAR PURPOSE.  See the GNU
;  General Public License for more details.
;
;  You should have received a  copy of the GNU General Public License
;  along  with this  program;  if  not, write  to  the Free  Software
;  Foundation,  Inc.,   59  Temple  Place,  Suite   330,  Boston,  MA
;  02111-1307 USA

; #####################################################################

;     include files
;     ~~~~~~~~~~~~~
      include C:\MASM32\INCLUDE\windows.inc
      include C:\MASM32\INCLUDE\masm32.inc
;      include C:\MASM32\INCLUDE\gdi32.inc
      include C:\MASM32\INCLUDE\user32.inc
      include C:\MASM32\INCLUDE\kernel32.inc
      include C:\MASM32\INCLUDE\Comctl32.inc
      include C:\MASM32\INCLUDE\comdlg32.inc
;      include C:\MASM32\INCLUDE\shell32.inc

;     libraries
;     ~~~~~~~~~
      includelib C:\MASM32\LIB\masm32.lib
;      includelib C:\MASM32\LIB\gdi32.lib
      includelib C:\MASM32\LIB\user32.lib
      includelib C:\MASM32\LIB\kernel32.lib
      includelib C:\MASM32\LIB\Comctl32.lib
      includelib C:\MASM32\LIB\comdlg32.lib
;      includelib C:\MASM32\LIB\shell32.lib

DlgFunc   PROTO :DWORD,:DWORD,:DWORD,:DWORD
decrypt   PROTO
; DlgDecoup PROTO :DWORD,:DWORD,:DWORD,:DWORD
; filesize PROTO :DWORD



.const
IDC_STATIC      equ -1
IDC_EDIT1       equ 3001
IDD_MAINDLG     equ 100
IDC_HD          equ 3008
IDC_DD          equ 3009
IDC_COUPER      equ 3010
IDC_APROPOS     equ 3011
IDC_QUITTER     equ 3012
IDD_APROPOS     equ 101
IDC_CHERCHER    equ 3013
IDD_DECOUP      equ 1000
TailleMax       equ 256
OutputSize      equ 259

.data
Filtres   db "Fichiers texte ou html",0 ,"*.txt;*.html",0
          db "Tous (*.*)", 0,"*.*", 0,0
NomApp    db "Konvert",0
Couper    db "&Convertir",0
EnCours   db "En cours...",0
Ouvrir    db "Ouvrir",0
APTxt     db "A propos de Konvert",0
APROPOS   db "Ce logiciel est sous licence GPL",13,10,13,10
          db "Auteur: Bruno Berteau",13,10,13,10
          db "Contact: bberteau@free.fr",13,10,13,10
          db "Site internet : http://perso.club-internet.fr/bberteau",0
            
Erreur    db "Erreur !",0
ErFichier db "Le fichier entr n'existe pas",0
ErEcrit   db "Le fichier ne peut pas tre cr dans ce rpertoire !",13,10
          db "Verifiez que le rpertoire n'est pas situ sur un CD-ROM.",0
ConvOK    db "Le fichier  t converti.",13,10,0
CRLF        db 13,10
ExtBak      db ".bak"
hInstance   dd 0
NomCoupe    db TailleMax dup (0)
NomBak      db TailleMax dup (0)

.data?
ofn OPENFILENAME<>
h_Fichier   dd ?
h_Coupe     dd ?
h_Bak       dd ?
h_BoutonC   dd ?
TailleF     dd ?
Buffer      db ?
Buffer2     db ?
NomFichier  db TailleMax dup(?)
 ; Compteur    dd ?
; NomCoupe  dd TailleMax+4 dup(?)
NbLus       dd ?
NbEcrits    dd ?
NomSPath    db TailleMax dup(?)
; BufferF     dd 20000h dup(?) 

.code
start:
	invoke GetModuleHandle,NULL
Crypt:
	mov hInstance,eax
	invoke DialogBoxParam,hInstance,IDD_MAINDLG,NULL,ADDR DlgFunc,NULL
	invoke ExitProcess,NULL

DlgFunc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL rect:RECT
        
	.if uMsg==WM_CLOSE
	   invoke EndDialog,hDlg,NULL
               
	.elseif uMsg==WM_INITDIALOG
          invoke GetDlgItem, hDlg, IDC_COUPER
          mov h_BoutonC, eax
          invoke EnableWindow, h_BoutonC, FALSE
          invoke LoadIcon,hInstance,500
          invoke SendMessage,hDlg,WM_SETICON,TRUE,eax

     .ELSEIF uMsg==WM_COMMAND
	  mov eax,wParam
        mov edx,eax
        .IF ax==IDC_APROPOS
            shr edx,16
	       .IF dx==BN_CLICKED
                invoke MessageBoxEx,hDlg,ADDR APROPOS,ADDR APTxt,MB_OK or MB_TASKMODAL,0
             .ENDIF   

        .ELSEIF ax==IDC_CHERCHER
            shr edx,16
              .IF dx==BN_CLICKED
                invoke  RtlZeroMemory, offset Buffer, TailleMax
                mov ofn.lStructSize,SIZEOF ofn
                push hDlg
                pop ofn.hWndOwner
                push hInstance
                pop ofn.hInstance
                mov ofn.lpstrFilter, OFFSET Filtres
                mov ofn.lpstrFile, OFFSET Buffer ; OFFSET Buffer
                mov ofn.nMaxFile, TailleMax
                mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_LONGNAMES or \
                   OFN_EXPLORER or OFN_HIDEREADONLY
                mov ofn.lpstrTitle, OFFSET Ouvrir
                invoke GetOpenFileName, ADDR ofn
                .IF eax==TRUE
                    invoke  RtlZeroMemory, offset NomSPath, 50
                    xor ecx,ecx
                    xor ebx,ebx
                    mov cx,ofn.nFileOffset
                    mov ebx, ofn.lpstrFile
                    add ebx,ecx
                    invoke lstrcat, offset NomSPath, ebx
                    invoke SetDlgItemText,hDlg,IDC_EDIT1, ofn.lpstrFile
                    invoke EnableWindow, h_BoutonC, TRUE
                .ENDIF
              .ENDIF 
               
        .ELSEIF ax==IDC_QUITTER
            shr edx,16
            .IF dx==BN_CLICKED
            invoke EndDialog,hDlg,NULL
            .ENDIF
        .ELSEIF ax==IDC_COUPER
             shr edx,16
             .IF dx==BN_CLICKED   
                  invoke GetDlgItemText,hDlg,IDC_EDIT1,ADDR NomFichier,TailleMax
                  invoke lnstr, offset NomFichier
                  .IF eax==0
                  .ELSE
                    invoke EnableWindow, h_BoutonC, FALSE
                    invoke SetDlgItemText, hDlg,IDC_COUPER,addr EnCours
                    invoke  RtlZeroMemory, offset NomBak, TailleMax
                    invoke lstrcat, offset NomBak, offset NomFichier
                    invoke lstrcat, offset NomBak, offset ExtBak
                    invoke CopyFile, offset NomFichier, offset NomBak, FALSE
                     .IF eax==-1
                      invoke MessageBoxEx,hDlg,ADDR ErFichier,ADDR Erreur,\
                        MB_OK or MB_TASKMODAL or MB_ICONWARNING,NULL
                     .ELSE
                       invoke CreateFile, ADDR NomFichier, GENERIC_WRITE, 0, 0, CREATE_ALWAYS,\
                        FILE_ATTRIBUTE_NORMAL, 0
                       mov h_Fichier, eax
                              .IF eax!=-1
                                  invoke CreateFile, ADDR NomBak, GENERIC_READ,\
                                    FILE_SHARE_READ,0, OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,0
                                  mov h_Bak, eax
                                  invoke GetFileSize, h_Bak, offset TailleF
                                  mov ecx,eax
                               Boucle:
                                  mov [TailleF],ecx
                                  invoke ReadFile,h_Bak, ADDR Buffer, 1, ADDR NbLus, NULL
                                  xor eax,eax
                                  mov al, Buffer
                                  .IF eax>31
                                      invoke WriteFile, h_Fichier, offset Buffer,1, OFFSET NbEcrits, NULL
                                  .ELSE
                                    .IF eax==13
                                      invoke WriteFile, h_Fichier, Offset CRLF, 2, OFFSET NbEcrits, NULL  
                                      invoke ReadFile, h_Bak, ADDR Buffer, 1, ADDR NbLus, NULL
                                      xor eax,eax
                                      mov al, Buffer
                                      .if eax!=10
                                        Invoke SetFilePointer, h_Bak, -1, NULL, FILE_CURRENT
                                      .endif
                                    .ELSEIF eax==10
                                      invoke WriteFile, h_Fichier, Offset CRLF, 2, OFFSET NbEcrits, NULL
                                    .ELSE
                                      invoke WriteFile, h_Fichier, Offset Buffer, 1, OFFSET NbEcrits, NULL
                                    .ENDIF
                                  .ENDIF
                                  mov ecx, [TailleF]
                                  dec ecx                                 
                                  jnz Boucle
                              Sortie:
                                  invoke CloseHandle,h_Fichier
                                  invoke CloseHandle,h_Coupe
                                  invoke EnableWindow, h_BoutonC, TRUE
                                  invoke SetDlgItemText,hDlg, IDC_COUPER,addr Couper
                                  invoke MessageBoxEx,hDlg,ADDR ConvOK,ADDR NomApp,MB_OK or MB_TASKMODAL,NULL
                                  invoke CloseHandle,h_Bak
                              .ELSE
                                  invoke MessageBoxEx,hDlg,ADDR ErEcrit, ADDR Erreur,\
                                    MB_OK or MB_TASKMODAL or MB_ICONWARNING,NULL
                                  invoke EnableWindow, h_BoutonC, TRUE
                                  invoke SetDlgItemText,hDlg, IDC_COUPER,addr Couper                                  
                              .ENDIF     
                     .ENDIF    
                  .ENDIF
             .ENDIF   
        .ENDIF       
     .ELSE
	mov eax,FALSE
	ret
     .ENDIF
     mov eax,FALSE
     ret
DlgFunc endp

end start
